include cx486def.h
code            segment
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; for MS-DOS .COM file
.8086
start:          jmp     main    ; JMP 50h ; EB 4E
align 2
SegTVRAM        DW      0A000h  ;
Seg_SYSTEM_BIOS DW      0FD80h  ; m[}[h̃VXeBIOS 0̃ZOg
VacantLocation  DW      F8_VACUNT
MemWinAddr      DW      0461h   ; EBhEI/O@nC]͕ʒl
MemWinDefault   DB      08h     ; ̃ftHg߂l  nC]͕ʒl10h
equip           DB      00h     ; foCX̊gBIOS̑
  SCSI_equip    equ     20h     ; SCSI BIOS bit
  SASI_equip    equ     40h     ; SASI BIOS bit
  SNDB_equip    equ     80h     ; SND  BIOS bit
flagset         DW      0000h     ; stObits
  F_EN_FLUSH    equ     0001h     ; 
  F_286BASE     equ     0002h
  F_HOLD_FLUSH  equ     0004h     
  F_HIRESO      equ     0008h     ; Œl(bitԍ)ɂύXs
  F_INDOS       equ     0010h
  F_HOOKED      equ     0020h     ; Œl(bitԍ)ɂύXs
  F_NO_HOOK     equ     0040h
  F_H98         equ     0080h     ; Œl(bitԍ)ɂύXs
  F_V86         equ     0100h
  F_NO_REGIDENT equ     0200h
  F_MEM768K     equ     0400h   ; 1= 768KB, 00640KB
  F_SYSCLK8M    equ     0800h   ; 1= SYSTEM CLOCK 8MHz, TIMER CLOCK 1.9968MHz
  F_SHODAI_XA   equ     1000h   ; 1 & hireso = XA flag
DIP_switch2     DB     0FFh
  F_DIPSW21ON   equ     01h     ; Œl(bitԍ)ɂύXs
  F_DIPSW27ON   equ     40h     ; Œl(bitԍ)ɂύXs
Padding         DB      00h

; 16oCgڂf[^
DATA_CCR_NCR_IPLW       label byte      ; IPLwarem[}[hp
        DB      0C0h,00000001b  ; Œ64KB̃LbVŊJn
        DB      0C1h,00000000b
        DB      0C4h,00h, 0C5h,0Fh, 0C6h,84h    ; NCR1  0F8000:32K
        DB      0C7h,00h, 0C8h,0Ah, 0C9h,07h    ; NCR2  0A0000:256K
        DB      0CAh,00h, 0CBh,0Eh, 0CCh,04h    ; NCR3  0E0000:32K
        DB      0CDh,00h, 0CEh,08h, 0CFh,06h    ; NCR4  080000:128K
Seg0000 label word
        DB      00h,00h,00h,00h ; ̃[͎gpĂ̂ō폜s
DATA_CCR_NCR_IPLW_H    label byte       ; IPLwarenC][hp
IF 0
        DB      0C0h,00000001b  ; Œ64KB̃LbVŊJn
        DB      0C1h,00000000b
        DB      0C4h,00h, 0C5h,0Fh, 0C6h,84h    ; NCR1  0F8000:32K
        DB      0C7h,00h, 0C8h,0Ch, 0C9h,06h    ; NCR2  0C0000:128K
        DB      0CAh,00h, 0CBh,0Eh, 0CCh,05h    ; NCR3  0E0000:64K
        DB      0CDh,00h, 0CEh,08h, 0CFh,07h    ; NCR4  080000:256K oN
        DB      00h,00h,00h,00h  ; ̃[͎gpĂ̂ō폜s
ENDIF
        DB      0C0h,00000000b  ; Œ64KB̃LbVŊJn
        DB      0C1h,00000000b
        DB      0C4h,00h, 0C5h,08h, 0C6h,07h    ; NCR1  080000:256K
        DB      0C7h,00h, 0C8h,0Ch, 0C9h,06h    ; NCR2  0C0000:128K
        DB      0CAh,00h, 0CBh,0Eh, 0CCh,06h    ; NCR3  0E0000:128K
        DB      0CDh,00h, 0CEh,10h, 0CFh,07h    ; NCR4  100000:256K
        DB      00h,00h
.8086
main:   ;=========== main =========
                mov     byte ptr cs:int21h,21h
                jmp     $+2
                call    CheckIPL_or_DOS
                xor     ax,ax
                mov     equip,al
                mov     Seg0000,ax  ; ϐ
                call    CheckResoMode   ; ? Hireso, set SegTVRAM

                mov     dx,offset msg_title
                call    _puts    ; ^Cg\
                jc      ErrorAbort      ; H98͑ΏۊOƂ
                in      al,31h          ; @B DIP-SW 2̒
                mov     DIP_switch2,al

                call    CheckCurrentCPU
                jc      ErrorAbort      ; CPU8086,V30,80286͑ΏۊOƂ
                call    CheckEPSON      ; EPSON@͎ɓȂ̂őΏۊOƂ
                jc      ErrorAbort
.386
                call    CheckEnv1       ; 낢`FbN flagset
                jc      ErrorAbort

                test    flagset,F_286BASE
                jz      @f
                mov     dx,offset msg_286base
                call    _puts    ; 286\
        @@:
                test    flagset,F_HIRESO
                jz      @f
                call    HiresoSetting
                jc      ErrorAbort
        @@:
                mov     al,DIP_switch2
                test    al,F_EN_FLUSH   ; ON==0, OFF(default)=1
                jnz     @f
                or      byte ptr CCR0_A, X_FLUSH
                mov     bx,offset DATA_CCR_NCR_IPLW
                or      byte ptr [bx+1], X_FLUSH
                mov     bx,offset DATA_CCR_NCR_IPLW_H
                or      byte ptr [bx+1], X_FLUSH
                or      flagset,F_EN_FLUSH      ; FLUSH# pin enable[h
                mov     dx,offset msg_en_flush
                call    _puts
        @@:
                mov     al,DIP_switch2
                test    al,F_DIPSW27ON  ; ON==0, OFF(default)=1
                jnz     @f
                mov     dx,offset msg_dis_hook
                call    _puts
                or      flagset,F_NO_HOOK       ; BIOS hookȂ[h
;;;;;;;;        or      flagset,F_HOLD_FLUSH    ; CCR0bit 5𗧂Ă
        @@:
                test    flagset,F_V86
                jz      @f      ; z86ł͓߂gȂ̂pass
                mov     eax,CR0
                or      eax,40000000h   ; kPLbV؂
                mov     CR0,eax
        @@:
                test    flagset,F_INDOS
                jz      @f
                mov     dx,offset msg_indos
                call    _puts
        @@:
                CALL    inquery_equip   ; gBIOS𒲍

;   DISK BIOS hook
                test    flagset,F_NO_HOOK
                jnz     @f
                call    HookInt1Bh
        @@:
                test    flagset,F_HOLD_FLUSH; łCCR0bit 5𗧂Ă
                jz      @f
                mov     dx,offset msg_no_hook   ; BIOS hookȂ[h
                call    _puts   ; ł邱Ƃ\

                mov     al,DIP_switch2
                test    al,F_DIPSW21ON
                jnz     no_holda
                mov     bx,offset DATA_CCR_NCR_IPLW     
                or      byte ptr [bx+1],X_HOLD_ST   ; CCR0bit 5Ă
                mov     bx,offset DATA_CCR_NCR_IPLW_H
                or      byte ptr [bx+1],X_HOLD_ST   ; CCR0bit 5Ă
                or      CCR0_A, X_HOLD_ST           ; CCR0bit 5Ă
no_holda:
        @@:
                test    flagset,F_286BASE ; 80286@ł BIOS RAM WȂ
                jz      @f
                or      flagset,F_NO_REGIDENT
                mov     dx,offset msg_patch_err
                call    _puts    
        @@:

; nC][hɂ IPLwaresɂ RAM BIOSCOLDZbg[`
; s, DOSŎsƂRAM BIOS Ȃ
                test    flagset,F_HIRESO
                jz      @f
                test    flagset,F_INDOS
                jz      @f
                or      flagset,F_NO_REGIDENT
                mov     dx,offset msg_noregident
                call    _puts
        @@:

;  RAM BIOS patch
                
                test    flagset,F_NO_REGIDENT
                jnz     NoRegidentF800  ; BIOS RAM WȂ

; RAM BIOSpb`R[hP(FFFF:0000̓)ύX
                mov     dx,MemWinAddr
                mov     al,0Eh
                out     dx,al
                mov     dx,053Dh
                mov     al,equip
                or      al,00000010b
                out     dx,al   ; RAM80000hɏo

                mov     di,000Fh
                mov     cx,6000h
                mov     ax,Seg_SYSTEM_BIOS  ; VXeBIOSZOg
                sub     ax,cx           ; 6000h
                mov     es,ax           ; RAM̃VXeBIOSZOg
                mov     cx,offset PatCodeRebootEntry_end
                mov     si,offset PatCodeRebootEntry
                sub     cx,si
        rep     movsb   ; pb`R[hP(FFFF:0000̓)ύX

; RAM BIOS pb`R[hQ
                mov     di,VacantLocation       ; 󂫒nItZbg
                mov     ax,(0F800h-6000h)       ; SYSTEM BIOS RAM ZOg
                mov     es,ax
                xor     ax,ax
                mov     cx,80/2   ; 80oCg󔒂Ŗ߂
        rep     stosw

                mov     di,VacantLocation
;;              mov     ax,(0F800h-6000h)    ; ɂĂ
;;              mov     es,ax
                mov     si,offset PatCodeCx486
                mov     cx,offset PatCodeCx486_end
                sub     cx,si
        rep     movsb   ; pb`R[hQ
                ; ŌɃ`FbNT킹
                call    CheckSum        ; ES=F800-6000h RAMŃT

                mov     dx,MemWinAddr
                mov     al,MemWinDefault
                out     dx,al
                mov     dx,053Dh
                mov     al,equip
                or      al,00000110b
                out     dx,al
                mov     dx,offset msg_succ      ; RAM BIOS ̐
                call    _puts
NoRegidentF800:

                call    SetCCRNCR_NOW           ; CACHEݒ̎s(IPLware)

                test    flagset,F_V86
                jz      ExitProgram
                mov     eax,CR0
                and     eax,9FFFFFFFh   ; kPLbVLɂ
                mov     CR0,eax
                jmp     ExitProgram
ErrorAbort:  ; G[
                mov     dx,offset msg_err
                call    _puts
                call    Beep3
ExitProgram:
                call    DisplayWait
                RET     ; IPLwarełI
;===============================================
HookInt1Bh      PROC   near     ; (DISK BIOS hook)
                xor     ax,ax
                mov     es,ax
                mov     di,WORK_AREA_04E0
                mov     cx,21   ; 21oCgNA
        rep     scasb
                or      cx,cx
                jnz     SomeCodeExist
; not found
                mov     ax,es:[1Bh*4]  ; ̊xN^eaxɓ
                mov     INT_1BH_org_ofs,ax ; 풓[`̏ʒuɂ\
                mov     ax,es:[1Bh*4+2]  ; ̊xN^eaxɓ
                mov     INT_1BH_org_seg,ax ; 풓[`̏ʒuɂ\
                mov     si,offset int1Bh_handler        ; int 1Bh[`
                mov     cx,offset int1Bh_handler_end    ; SYSTEM BIOSCOPY
                sub     cx,si                           ; 鏀
                mov     di,WORK_AREA_04E0
        rep     movsb   ; pb`
                mov     dx,offset msg_hook_now
                call    _puts
AlreadyStayedEntry:
                cli     ; xN^ύXɍsi̊Ԋ֎~j
                mov     word ptr es:[01Bh*4+0],WORK_AREA_04E0
                mov     word ptr es:[01Bh*4+2],0000h    ; ZOg͒萔
                sti
                clc
                ret
AlreadyStayed:  
                mov     dx,offset msg_hooked
                call    _puts
                jmp     AlreadyStayedEntry
SomeCodeExist: ; R[hꍇAr
                mov     di,WORK_AREA_04E0
                mov     si,offset int1Bh_handler        ; int 1Bh[`
                add     si,8    ; O8byteWv͋@ɂłȂ
                add     di,8    ; PUSH AXȍ~̈v𒲂ׂ̂ŁAWoCgi߂Ă
                mov     cx,offset int1Bh_handler_end    ; SYSTEM BIOSCOPY
                sub     cx,si                           ; 鏀
        rep     cmpsb
                or      cx,cx
                jz      AlreadyStayed
                or      flagset,F_HOLD_FLUSH
                or      flagset,F_NO_HOOK
                stc
                ret
HookInt1Bh      ENDP

;----------------------------------------------
;       HiresoSetting
;----------------------------------------------
HiresoSetting   PROC   near
                mov     dx,offset msg_hireso    ; nC]ł邱Ƃ̕\
                call    _puts
                push    ds
                mov     ds,Seg0000
                mov     al,ds:[0501h]
                pop     ds
                mov     ah,al
                and     ah,00000111b
                cmp     ah,00000101b
                jne     @f
                or      flagset,F_MEM768K
        @@:     
                test    flagset,F_INDOS
                jz      @f
;               mov     dx,offset msg_mem640K
;               call    _puts
        @@:
                
                test    al,10000000b
                jz      @f
                or      flagset,F_SYSCLK8M
                mov     dx,offset msg_sclk8M
                call    _puts
                
        @@:     test    al,00100000b
                jnz     @f
                or      flagset,F_SHODAI_XA
                mov     dx,offset msg_shodai
                call    _puts
                stc
                ret
        @@:
; nC]ł̒萔u
                mov     MemWinAddr,0091h        ; 
                mov     MemWinDefault,10h       ; EBhE=10h
                test    flagset,F_INDOS
                jz      XMS_NotExist
                mov     ax,4300h
                int     2Fh             ; ? XMM exist
                cmp     al,80h
                jne     XMS_NotExist
                mov     MemWinDefault,08h       ; XMS EBhE=08
XMS_NotExist:
                mov     Seg_SYSTEM_BIOS,0F800h  ; VXeBIOS
                mov     ax,F8_VACUNT_H          ; 󂫒nItZbg
                mov     VacantLocation,ax       ; ɃZbg
                mov     PatOffset,ax            ; 
;                mov     ax,offset DATA_CCR_NCR_ROM

                mov     ax, TabelCCRNCR
                add     ax,HIRESO_SHIFT        ; shift hireso
                mov     TabelCCRNCR, ax   ; CCRNCRe[üʒuϐ
; nC]p̂̂Rs[ăe[uu
                test    flagset,F_INDOS
                jz      MaxAddr_AFFFF
                mov     dx,offset EMMXXXX0
                xor     bx,bx
                mov     cx,0000h
                mov     ax,3D00h
                DB      0CDh
int21h:         DB      00h
                jnc     MaxAddr_AFFFF
                test    flagset,F_MEM768K
                jz      MaxAddr_AFFFF
                mov     al,0
                mov     bx, offset MEM640K
                mov     byte ptr cs:[bx+1],al
                mov     byte ptr cs:[bx+3],al
                mov     byte ptr cs:[bx+5],al
                jmp     $+2
                mov     dx,offset msg_BFFFF
                call    _puts
MaxAddr_AFFFF:
                mov     di,offset DATA_NCR_ROM  ; CCRNCRe[uRs[㏑
                mov     si,offset DATA_NCR_ROM_H
                jmp     $+2
                push    cs
                pop     es
                mov     cx,13   ; 13[hԂ
        rep     movsw
                clc
                ret
HiresoSetting   ENDP
                
;  
;msg_title       DB 0E5h," IPLware Cyrix486nCPU̷հèè CPUؾ߯t 1.01 (C)2024 ܂ ",13,10,0
msg_title       DB 0E5h," Cyrix486SLC/DLC/SRx2/DRx2 ̷հèè CPUؾ߯t 1.10 (C)2024 ܂ ",13,10,0
msg_BFFFF       DB 0E1h,"   B0000h`gEMS͌Ȃ̂, BFFFFh܂łLbV\ɂ܂.",13,10,0
msg_err         DB 041h,"   ̋@CPUł͓삵܂. ~܂.  ",13,10,0
msg_indos       DB 0E1h,"   MS-DOSŎsł.  ",13,10,0
msg_v86         DB 0C1h,"   zWU[hł̎sł.  ̂܂܃t[Y邱Ƃ܂.",13,10,0
msg_hooked      DB 0A1h,"    DISK BIOS int 1Bh ւ̃tbNׂ͈Ă܂.",13,10,0
msg_hook_now    DB 081h,"   DISK BIOS int 1Bh ւ̃tbNs܂.  ",13,10,0
msg_no_hook     DB 061h,"   DISK BIOS int 1Bh ւ̃tbN͍s܂.  ",13,10,0
msg_succ        DB 0E1h,"   SYSTEM BIOS RAM ւ̃pb`s܂.    ",13,10,0
msg_patch_err   DB 0C1h,"   RAM BIOS̖@łSYSTEM BIOSւ̃pb`(Rؾ)͂ł܂. ",13,10,0
msg_eq_scsi     DB 0E1h,"   SCSI HDD Ă܂.  ",13,10,0
msg_eq_sasi     DB 0E1h,"   SASI HDD Ă܂.  ",13,10,0
msg_eq_sndb     DB 0E1h,"   SOUND BIOS oĂ܂.  ",13,10,0
msg_eq_none     DB 0E1h,"   Built-in ӑůgBIOS͂ЂƂ܂ł.  ",13,10,0
msg_hireso      DB 0E1h,"   nC][V[hŎsĂ܂.  ",13,10,0
msg_286base     DB 0E1h,"   80286 Cyrix486SLC/DLC ڂւ@ŎsĂ܂. ",13,10,0
msg_noregident  DB 0A1h,"   nC][hDOSsɂ̓R[hZbg[`̏s܂.",13,10,0
msg_shodai      DB 061h,"   @PC-98XAł͂ȂłI",0
;msg_mem640K     DB 0E1h,"   C̃TCY640KBɐAB0000h`LbVsƂ܂.",13,10,0
msg_sclk8M      DB 0E1h,"   VXeNbNWlg@ł.",13,10,0
msg_en_flush    DB 0E1h,"   DIP SWITCH 2-1 ON: FLUSH#̓sLɂ܂.  ",13,10,0
msg_dis_hook    DB 0E1h,"   DIP SWITCH 2-7 ON: DISK BIOS int 1Bh ւ̯͍s܂.  ",13,10,0
ROW             DW      9
COLUMN          DW      0
COLOR_ATTRIB    DB      0E1h
;--------------------------------------------------------------------------
;       CheckIPL_or_DOS 
;--------------------------------------------------------------------------
CheckIPL_or_DOS PROC   near
                and     si,0FF00h
                cmp     si, 0300h       ; IPLwareo[W 3H
                je      IPLWver3
                mov     ax,cs
                cmp     ax,6000h
                je      IsIPLW
                cmp     ax,7000h
                je      IsIPLW
                jmp     IsDOS
IsIPLW:         jmp     NotInDOS
IPLWver3:       or      di,di           ; 
                jz      NotInDOS        ; DI0ȂIPLware낤
IsDOS: ; DOSƔ
                mov     flagset,F_INDOS ; DOStO𗧂Ă
                mov     byte ptr msg_title, 0A5h
NotInDOS:       nop
                ret
CheckIPL_or_DOS ENDP

;------------------------------------
;       CheckSum
;------------------------------------
CheckSum        PROC   near
                mov     ax,(0F800h-6000h)
                mov     es,ax

                mov     bx,offset PatCodeSUM
                xor     ax,ax
                mov     word ptr es:[bx],ax     ; 0 
                mov     dx,ax
                mov     di,ax
                mov     cx,8000h/2      ; F800-FFFF 32KB(4000[h)

          @@:   mov     ax,es:[di]      ;  AXɎ荞
                inc     di
                inc     di      ; P[hOi
                add     dl,al   ; T̒~
                add     dh,ah
               loop     @b
                neg     dl      ; lKl
                neg     dh      ; DL͋,DH͊AhX
                mov     word ptr es:[bx],dx
                ret
CheckSum        ENDP


;------------------
include ENVCHK.S
;------------------

;---------------------------------------------------------------
;       SetCCRNCR_NOW  
;---------------------------------------------------------------
SetCCRNCR_NOW  PROC   near     ; DOS/IPLW , NORM/HIRES
                test    flagset,F_INDOS
                jz      ExecInIPLW
; DOS and RESET
                mov     si,offset DATA_CCR_NCR_ROM
                mov     cx,15   ; 15 = The number of dataset
                call    SetCCRNCR_LoopSet15
                ret
ExecInIPLW:
                mov     si,offset DATA_CCR_NCR_IPLW
                test    flagset,F_HIRESO
                jz      @f
                mov     si,offset DATA_CCR_NCR_IPLW_H
        @@:     mov     cx,15   ; 15 = The number of dataset
                call    SetCCRNCR_LoopSet15
                ret
SetCCRNCR_NOW  ENDP

SetCCRNCR_LoopSet15     PROC   near
        @@:
                DB      02Eh
                lodsw
                out     22h,al
                xchg    al,ah
                out     23h,al
               loop     @b
                ret
SetCCRNCR_LoopSet15     ENDP
;---------------------------
include equip.s
include putsdc.s
include putscc.s
;---------------------------

DATA_NCR_ROM_H label byte       ; nC]pCCR,NCRe[u ċNp
        DB      0C4h,00h, 0C5h,0Fh, 0C6h,84h    ; NCR1  0F8000:32K
        DB      0C7h,00h, 0C8h,0Ch, 0C9h,06h    ; NCR2  0C0000:128K
        DB      0CAh,00h, 0CBh,0Eh, 0CCh,05h    ; NCR3  0E0000:64K
MEM640K DB      0CDh,00h, 0CEh,0Bh, 0CFh,05h    ; NCR4  0B0000:64K
        DB      00h,00h         ; Using
        DW      0000h

;------------------------------------------------------------
int1Bh_handler  label byte      ; 1nt1Bh̓ ; tOۑ 21bytes
                wbinvd
                pushf
                DB      9Ah     ; call far ptr long-imm
INT_1BH_org_ofs DW      1A82h   ; { INT 1BhxN^AhXi[ofs
INT_1BH_org_seg DW      0FD80h  ; { INT 1BhxN^AhXi[seg
                push    ax
                lahf            ; flag-->AH
                xchg    sp,bp
                mov     [bp+6],ah       ; X^bÑtOset
                xchg    bp,sp
                pop     ax
                invd
                IRET
int1Bh_handler_end      label byte
;--------------------------------------------
PatCodeRebootEntry      label   byte
                DB      0EAh            ; absolute far JUMP code
PatOffset       DW      F8_VACUNT
                DW     0F800h
                NOP
                NOP
                NOP
PatCodeRebootEntry_end  label   byte
;---------------------------------------------------------------------------
EMMXXXX0        DB      "EMMXXXX0",0

;===========================
DD      0EEEEEE00h,0EEEEEEEEh
;===========================

align 16
include coldrbt.s       ; ITF/BIOS ROM code

SegTempMem      label   word
                DB      16384 dup(?)

code            ends
                end  start
