CX486DISP       equ     1
include cx486def.h
_puts   equ     _putsCC
code            segment
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; for MS-DOS .COM file
.8086
start:          jmp     main
msg_title DB 0E5h," Cyrix486 SLC/DLC/SRx2/DRx2 LV̏ԕ\ 2.10  Copyright(C) 2024 ܂ ",13,10,0
align 2
Seg0000         DW      0
SegTVRAM        DW      0A000h
ROW             DW      9
COLUMN          DW      0
COLOR_ATTRIB    DB      0
flagset         DB      00h     ; stObits
  F_CPUID       equ     01h
  F_EN_FLUSH    equ     01h     ; 
  F_286BASE     equ     02h
; F_CPU386      equ     04h
  F_HOLD_FLUSH  equ     04h     
  F_HIRESO      equ     08h     ; Œl(bitԍ)ɂύXs
  F_INDOS       equ     10h
  F_HOOKED      equ     20h     ; Œl(bitԍ)ɂύXs
  F_NO_HOOK     equ     40h
  F_DIPSW27ON   equ     40h
  F_V86         equ     80h
  F_H98         equ     80h     ; Œl(bitԍ)ɂύXs

CCR0            DB      0
CCR1            DB      0
NCR1            DB      0       ; (null)
NCR1_L          DB      84h     ; bit 15-12 4K- , size(4bit) 1=4K,3=16K,4=32K,5=64K,6=128K
NCR1_M          DB      0Fh     ; bit 23-16 64K-
NCR1_H          DB      0       ; bit 31-24 16M-
NCR2            DB      0       ; (null)
NCR2_L          DB      7       ; bit 15-12 4K- , size(4bit) 1=4K,3=16K,4=32K,5=64K,6=128K
NCR2_M          DB      0Ah     ; bit 23-16 64K-
NCR2_H          DB      00h     ; bit 31-24 16M-
NCR3            DB      0       ; (null)
NCR3_L          DB      4       ; bit 15-12 
NCR3_M          DB      0Eh     ; bit 23-16 64K-
NCR3_H          DB      00h     ; bit 31-24 16M-
NCR4            DB      0 
NCR4_L          DB      9       ; bit 15-12 4K- , size(4bit) 8=512,9=1M,10=2M
NCR4_M          DB      0F0h    
NCR4_H          DB      00h

main:           
                xor     ax,ax
                call    CheckResoMode   ; ? Hireso, set SegTVRAM
                mov     dx,offset msg_title
                call    _puts    ; ^Cg\
                
                jc      ErrorAbort      ; H98͑ΏۊOƂ
                call    CheckCurrentCPU
                jc      ErrorAbort      ; CPU8086,V30,80286͑ΏۊOƂ
                call    CheckEPSON      ; EPSON@͎ɓȂ̂őΏۊOƂ
                jc      ErrorAbort
.386
                call    CheckEnv1       ; 낢`FbN flagset
                jc      ErrorAbort

                call    CheckHookedBIOS
                jnz     @f      ; zero=itti
                mov     ax,offset msg_hook_patch
                mov     msgptr_hook,ax
                or      flagset,F_HOOKED
        @@:

                call    InvestigateCCR
                call    DisplayCCR01
                mov     dx,offset msg_NCRXX
                call    _puts  
                call    DisplayNCR1
                call    DisplayNCR2
                call    DisplayNCR3
                call    DisplayNCR4
ExitProgram:
                mov     ah,4Ch
                int     21h
ErrorAbort:     mov     dx,offset msg_err
                call    _puts
                jmp     ExitProgram

;--------------------------
InvestigateCCR  PROC   near
                mov     al,0C0h
                out     22h,al
                in      al,23h
                mov     CCR0,al
                mov     al,0C1h
                out     22h,al
                in      al,23h
                mov     CCR1,al
                ret
InvestigateCCR  ENDP

DisplayCCR01    PROC   near
; CCR0 
; bit ̈Ӗ (80386ɂȂs)
; 7     1 SUSP#sL
; 6     1 direct mapped, 0 2-way associativeLbV 
; 5     1 HOLDXe[gɃtbV  0 ? Ԃ3,4ƔrH
; 4     1 FLUSH#̓sLÃs̋쓮ɂtbV 
; 3     1 KEN#̓sLÃs̋쓮ɂLbV 
; 2     1 1A20Mask# ̓sL  
; 1     1 640KB`1MBROMLbVɂ, 0ł̓LbVL
; 0     1 eX1MBԖ̍ŏ64KBLbVȂ, XAnC]ňӖH
                mov     dx,offset msg_CCRXX
                call    _puts

                mov     dx,offset msg_repl_en
                test    byte ptr CCR1,00000001b
                jnz     @f
                mov     dx,offset msg_repl_dis
        @@:     call    _puts

                mov     dx,offset msg_SUSP_en
                test    byte ptr CCR0,10000000b
                jnz     @f
                mov     dx,offset msg_SUSP_dis
        @@:     call    _puts

                mov     dx,offset msg_a20m_en
                test    byte ptr CCR0,00000100b
                jnz     @f
                mov     dx,offset msg_a20m_dis
        @@:     call    _puts

                mov     dx,offset msg_ken_en
                test    byte ptr CCR0,00001000b
                jnz     @f
                mov     dx,offset msg_ken_dis
        @@:     call    _puts

                mov     dx,offset msg_flush_en
                test    byte ptr CCR0,00010000b
                jnz     @f
                mov     dx,offset msg_flush_dis
        @@:     call    _puts


                mov     dx,offset msg_hold_en
                test    byte ptr CCR0,00100000b
                jnz     @f
                mov     byte ptr msg_hold_dis,0E1h
                mov     dx,offset msg_hold_dis
                call    _puts
                mov     dx,msgptr_hook
        @@:     call    _puts

                mov     dx,offset msg_cache_1
                test    byte ptr CCR0,01000000b
                jnz     @f
                mov     dx,offset msg_cache_2
        @@:     call    _puts

                mov     dx,offset msg_base64K_dis
                test    byte ptr CCR0,00000001b
                jnz     @f
                mov     dx,offset msg_base64K_en
        @@:     call    _puts

                mov     dx,offset msg_640K_1M_dis
                test    byte ptr CCR0,00000010b
                jnz     @f
                mov     dx,offset msg_640K_1M_en
        @@:     call    _puts

                ret
DisplayCCR01    ENDP

DisplayNCR1     PROC   near
                mov     dx,offset msg_NCR1
                call    _puts

                mov     al,0C6h
                out     22h,al
                in      al,23h
                mov     NCR1_L,al
                mov     al,0C5h
                out     22h,al
                in      al,23h
                mov     NCR1_M,al
                mov     al,0C4h
                out     22h,al
                in      al,23h
                mov     NCR1_H,al

                mov     al,NCR1_H
                shl     eax,8
                mov     al,NCR1_M
                shl     eax,8
                mov     al,NCR1_L
                and     al,0F0h
                shl     eax,8
                mov     al,NCR1
                call    digitlx
                mov     dx,offset msg_size_is
                call    _puts
                xor     ax,ax

                mov     al,NCR1_L
                and     al,0Fh
                mov     bx,offset SizeParamPtr
                shl     ax,1
                add     bx,ax
                mov     dx,[bx]
                call    _puts
                mov     dx,offset msg_CRLF
                call    _puts
                ret
msg_NCR1        DB      0E1h,"    NCR1 : ",0
DisplayNCR1     ENDP

DisplayNCR2     PROC   near
                mov     dx,offset msg_NCR2
                call    _puts
                mov     al,0C9h
                out     22h,al
                in      al,23h
                mov     NCR2_L,al
                mov     al,0C8h
                out     22h,al
                in      al,23h
                mov     NCR2_M,al
                mov     al,0C7h
                out     22h,al
                in      al,23h
                mov     NCR2_H,al

                mov     al,NCR2_H
                shl     eax,8
                mov     al,NCR2_M
                shl     eax,8
                mov     al,NCR2_L
                and     al,0F0h
                shl     eax,8
                mov     al,NCR2
                or      eax,eax
                jnz     @f
                mov     dx,offset msg_invalid
                call    _puts
                jmp     to_size_display2
        @@:     call    digitlx
to_size_display2:
                mov     dx,offset msg_size_is
                call    _puts
                xor     ax,ax

                mov     al,NCR2_L
                and     al,0Fh
                mov     bx,offset SizeParamPtr
                shl     ax,1
                add     bx,ax
                mov     dx,[bx]
                call    _puts
                mov     dx,offset msg_CRLF
                call    _puts
                ret
msg_NCR2        DB      0E1h,"    NCR2 : ",0
DisplayNCR2     ENDP

DisplayNCR3     PROC   near
                mov     dx,offset msg_NCR3
                call    _puts
                mov     al,0CCh
                out     22h,al
                in      al,23h
                mov     NCR3_L,al
                mov     al,0CBh
                out     22h,al
                in      al,23h
                mov     NCR3_M,al
                mov     al,0CAh
                out     22h,al
                in      al,23h
                mov     NCR3_H,al

                mov     al,NCR3_H
                shl     eax,8
                mov     al,NCR3_M
                shl     eax,8
                mov     al,NCR3_L
                and     al,0F0h
                shl     eax,8
                mov     al,NCR3
                or      eax,eax
                jnz     @f
                mov     dx,offset msg_invalid
                call    _puts
                jmp     to_size_display3
        @@:     call    digitlx
to_size_display3:
                mov     dx,offset msg_size_is
                call    _puts
                xor     ax,ax

                mov     al,NCR3_L
                and     al,0Fh
                mov     bx,offset SizeParamPtr
                shl     ax,1
                add     bx,ax
                mov     dx,[bx]
                call    _puts
                mov     dx,offset msg_CRLF
                call    _puts
                ret
msg_NCR3        DB      0E1h,"    NCR3 : ",0
DisplayNCR3     ENDP

DisplayNCR4     PROC   near
                mov     dx,offset msg_NCR4
                call    _puts
                mov     al,0CFh
                out     22h,al
                in      al,23h
                mov     NCR4_L,al
                mov     al,0CEh
                out     22h,al
                in      al,23h
                mov     NCR4_M,al
                mov     al,0CDh
                out     22h,al
                in      al,23h
                mov     NCR4_H,al

                mov     al,NCR4_H
                shl     eax,8
                mov     al,NCR4_M
                shl     eax,8
                mov     al,NCR4_L
                and     al,0F0h
                shl     eax,8
                mov     al,NCR4
                or      eax,eax
                jnz     @f
                mov     dx,offset msg_invalid
                call    _puts
                jmp     to_size_display4
        @@:     call    digitlx
to_size_display4:
                mov     dx,offset msg_size_is
                call    _puts
                xor     ax,ax

                mov     al,NCR4_L
                and     al,0Fh
                mov     bx,offset SizeParamPtr
                shl     ax,1
                add     bx,ax
                mov     dx,[bx]
                call    _puts
                mov     dx,offset msg_CRLF
                call    _puts
                ret
msg_NCR4        DB      0E1h,"    NCR4 : ",0
DisplayNCR4     ENDP
;--------------------------------------------------------------------------
;       CX486IPL.COM 
;--------------------------------------------------------------------------
CheckHookedBIOS PROC   near
                xor     ax,ax
                mov     es,ax
                mov     di,WORK_AREA_04E0     ;04E0h
                mov     si,offset HookCode
                mov     cx,offset HookCode_end
                sub     cx,si
                sub     cx,8
                add     si,8
                add     di,8
          rep   cmpsb
                or      cx,cx
                ret
                
HookCode        label   byte
                wbinvd
                pushf
                DB      9Ah     ; call far ptr long-imm
INT_1BH_org_ofs DW      1A82h   ; { INT 1BhxN^AhXi[ofs
INT_1BH_org_seg DW      0FD80h  ; { INT 1BhxN^AhXi[seg
                push    ax
                lahf
                xchg    sp,bp
                mov     [bp+6],ah
                xchg    bp,sp
                pop     ax
                invd
                IRET
HookCode_end        label   byte
CheckHookedBIOS ENDP

include ENVCHK.S

;-----------------------------------------------------------
;       CheckEPSON
;-----------------------------------------------------------
CheckEPSON      PROC   near
                xor     ax,ax
                mov     es,ax
                mov     ax,0FD80h       ; seg
                mov     bx,0002h        ; ofs
                mov     cx,2A27h        ; EPSON 27h,2Ah (Normal)
                test    byte ptr es:[0501h],8
                jz      EpsonNormalMode
                mov     ax,0F800h       ; seg
                mov     bx,07F70h       ; ofs
                mov     cx,1827h        ; EPSON 27h,18h (Hireso)
EpsonNormalMode:  
                mov     es,ax
                cmp     es:[bx],cx      ; compare
                je      IsEPSONPC
                clc
                ret
IsEPSONPC:      
                mov     al,es:[3]       ; EPSON ID
                mov     ah,0
;                mov     dx,offset msg_EPSON
;                call    _puts
;                or      flagset,F_NO_HOOK
                stc     ; CY=EPSON PC
                ret
;msg_EPSON       DB      041h,"EPSON@RAM BIOSpb`DISK BIOStbN̑ΏۊOł. ᑬœ.",13,10,0
CheckEPSON      ENDP

;--------------------------
include putsDC.s                ; \(DOS)
;----------------------------- 16i\ --------------------
.386
                PUBLIC  _digit386
_digit386       PROC    NEAR
                push    es
                push    si
                push    bx
                push    ds
                pop     es
                push    eax
                cmp     cx,0FFFFh
                je      Noalign386
                xor     dx,dx
                mov     ax,128
                div     _digit_div
                cmp     cx,ax
                jbe     cx_ok1_386
                mov     cx,ax
cx_ok1_386:         
                cmp     cx,1
                jae     cx_ok2_386
                mov     cx,ax
cx_ok2_386:     nop
Noalign386:     nop
                std
                 mov     di,offset ds:_convert$end
                 xor     ebx,ebx
                 mov     bx,ds:_digit_div
                 mov    al,0
                 stosb   
                pop     eax  ;   ax=value
                xor     edx,edx
_digit386_ent:     
                div     ebx
                mov     si,offset ds:_hextbl
                add     si,dx
                movsb
                dec     cx
                xor     edx,edx
                or      eax,eax
                jnz     _digit386_ent
_digit386_end:     
                cmp     cx,33
                jae     digit386_err
                or      cx,cx
                jz      digit386_err
                mov     al,_digit_zsup
digit386_spc_loop: stosb
               loop     digit386_spc_loop
digit386_err:   
                mov     al,COLOR_ATTRIB
                stosb
                cld
                inc     di
                mov     dx,di
                pop     bx
                pop     si
                pop     es
                ret
_digit386       ENDP

;----------------------------------------------
;       digitlx
;----------------------------------------------
digitlx          PROC    near
                 pushad
                 mov     COLOR_ATTRIB,0E1h
                 mov     cx,8
                 mov     _digit_zsup,'0'
                 mov     _digit_div,16
                 call    _digit386
                 call    _puts
                 popad
                 ret
digitlx          ENDP
_digit_div      DW      10
_digit_zsup     DB      ' '
_hextbl         DB      "0123456789ABCDEF"
$KetaBuf33      DB      "                                 "
_convert$end    DB      0
;--------------------------------------------------------------------
msg_err         DB      041h,"    ̋@CPUł͓삵܂. ~܂.",13,10,0
msg_cx586       DB      041h,"    CPU Cyrix5x86ł.",13,10,0
msg_not_cx486   DB      0C1h,"    CPU Cyrix486n ł͂܂.",13,10,0
msg_cpuid       DB      0C1h,"    CPU CPUID T|[gĂ܂.",13,10,0
msg_not386      DB      041h,"    CPU32biti80386ȏjł͂܂.",13,10,0
msg_hook_patch  DB      0E1h,"     CX486IPL ɂDISK̯ς",13,10,0
msgptr_hook     DW      offset msg_CRLF
msg_V86         DB      0C1h,"    zWU[hŎsĂ܂. \Ȃꍇ܂.",13,10,0
msg_CRLF        DB      0E1h,13,10,0
msg_size_is     DB      0E1h," , ",0
msg_640K_1M_dis DB      0E1h,"    bit1  1   640KB-1MB   ",13,10,0
msg_640K_1M_en  DB      0E1h,"    bit1  0   {I 640KB-1MB LbVL  ",13,10,0
msg_SUSP_dis    DB      0E1h,"    bit7  0   SUSP#s  ",13,10,0
msg_SUSP_en     DB      0E1h,"    bit7  1   SUSP#sL  i{ɔzĂ邩͕sj  ",13,10,0
msg_repl_dis    DB      0E1h,"    CCR1  0   RPLSET/RPLVAL#    ",13,10,0
msg_repl_en     DB      0E1h,"    CCR1  1   RPLSET/RPLVAL#  gp  i{ɔzĂ邩͕sj  ",13,10,0
msg_a20m_dis    DB      0E1h,"    bit2  0   A20MASK#    ",13,10,0
msg_a20m_en     DB      0E1h,"    bit2  1   A20MASK#  gp  i{ɔzĂ邩͕sj  ",13,10,0
msg_ken_dis     DB      0E1h,"    bit3  0   KEN#    ",13,10,0
msg_ken_en      DB      0E1h,"    bit3  1   KEN#  gpi{ɔzĂ邩͕sj  ",13,10,0
msg_flush_dis   DB      0E1h,"    bit4  0   FLUSH#    ",13,10,0
msg_flush_en    DB      0C1h,"    bit4  1   FLUSH#  Li{ɔzĂ邩͕sj  ",13,10,0
msg_hold_dis    DB      0C1h,"    bit5  0   HOLD ðĂׯȂ  ",0
msg_hold_en     DB      0E1h,"    bit5  1   HOLD ðĂׯiSxȂj ",13,10,0
msg_cache_2     DB      0E1h,"    bit6  0    2-way associative  ",13,10,0
msg_cache_1     DB      0E1h,"    bit6  1    Direct Map   ",13,10,0
msg_base64K_en  DB      0E1h,"    bit0  0   1MBԖ̍ŏ64KBLbVɂȂ",13,10,0
msg_base64K_dis DB      0E1h,"    bit0  1   1MBԖ̍ŏ64KB𷬯Ȃ",13,10,0
msg_CCRXX       DB      0A1h,"    CCR1,CCR0̐ݒ",13,10,0
msg_NCRXX       DB      0A1h,"    Non cache region̐ݒ",13,10,0
msg_invalid     DB      0E1h,"  ---   ",0
msg_00          DB      0E1h,"ݒ肳Ă܂",0 ;  NCRx_L4bitl
msg_4K          DB      0E1h,"size 4KB",0    ; 1  NCRx_L4bitl
msg_8K          DB      0E1h,"size 8KB",0    ; 2     //
msg_16K         DB      0E1h,"size 16KB",0   ; 3
msg_32K         DB      0E1h,"size 32KB",0   ; 4
msg_64K         DB      0E1h,"size 64KB",0   ; 5
msg_128K        DB      0E1h,"size 128KB",0  ; 6
msg_256K        DB      0E1h,"size 256KB",0  ; 7
msg_512K        DB      0E1h,"size 512KB",0  ; 8
msg_1M          DB      0E1h,"size 1MB",0    ; 9
msg_2M          DB      0E1h,"size 2MB",0    ; 10
msg_4M          DB      0E1h,"size 4MB",0    ; 11
msg_8M          DB      0E1h,"size 8MB",0    ; 12
msg_16M         DB      0E1h,"size 16MB",0   ; 13
msg_32M         DB      0E1h,"size 32MB",0   ; 14     //
msg_4G          DB      0C1h,"4GBi܂Sŷj",0    ; 15  NCRx_L4bitl

SizeParamPtr    label   word
        DW      offset msg_00, offset msg_4K, offset msg_8K
        DW      offset msg_16K, offset msg_32K, offset msg_64K
        DW      offset msg_128K, offset msg_256K, offset msg_512K
        DW      offset msg_1M, offset msg_2M, offset msg_4M
        DW      offset msg_8M, offset msg_16M, offset msg_32M, offset msg_4G

code            ends
                end  start
