;--------------------------------------------------------------------------
;       CheckEnv1       V86,CPUID,InDOS,Hireso ƃtOւ̋L^
;--------------------------------------------------------------------------
CheckEnv1       PROC   near     ; 80386ȏ
                smsw    ax
                test    ax,1            ;  Protected mode ɂ邩
                jz      in_real_mode    ; veNg[htO𗧂Ă
                or      flagset,F_V86
                mov     dx,offset msg_V86
                call    _puts
in_real_mode:
                mov     es,Seg0000
                mov     ax,es:[0486h]   ; VXeʈCPUIDi[ꏊ
                or      ax,ax
                jz      NoSysWork0486   ; 286⌳386SXł0
                and     ax,0FF0h        ; ODPtO
                cmp     ax,0410h        ; 410
                jb      NoCyrix
                cmp     ax,0430h        ; 430ȏ
                jae     NoCyrix         ; 486DX2ȏ5x86͏
NoSysWork0486: ; 286⌳386SXȂƂ, ID=41x,42x̂Ƃ͂ɗ
                mov     al,0C1h
                out     22h,al
                in      al,23h
                cmp     al,0FFh
                je      NoCyrix ; I/O͓ǂ߂ȂΔCyrix
                mov     al,00h
                out     22h,al
                out     23h,al  ; reset Cyrix registers
Cyrix:          
                clc     ; Cyrix SLC/DLCnł
                ret
NoCyrix:        stc     ; łȂ
                ret
CheckEnv1       ENDP

;--------------------------------------------------------------------------
;       CheckResoMode   
;--------------------------------------------------------------------------
CheckResoMode   PROC   near
                mov     es,Seg0000
                mov     al,es:[0501h]   ; nC]`FbN
                test    al,F_HIRESO
                jz      @f
                mov     SegTVRAM,0E000h
                or      flagset,F_HIRESO ; nC]tO𗧂Ă
                test    flagset,F_INDOS
                jz      @f
                mov     byte ptr msg_title, 065h
        @@: 
                mov     al,es:[0480h]   ; 80286machine/80386machine`FbN
                and     al,00000011b
                cmp     al,00000011b
                je      @f
                cmp     al,00000001b
                jne     LessThan286
                or      flagset,F_286BASE  ; 286tO𗧂Ă
        @@:
                mov     al,es:[0458h]   ; H98`FbN
                test    al,F_H98
                jz      @f
                stc
                ret
        @@:     clc
                ret
CheckResoMode   ENDP

;------------------------------
;       CheckCurrentCPU 
;------------------------------
CheckCurrentCPU PROC   near     ; CPU̐`FbN
                pushf
                pop     ax
                pushf
                or      ax,4000h
                push    ax
                popf
                pushf
                pop     ax
                popf
                and     ax,0C000h
                cmp     ax,4000h
                je      CPUis386
LessThan286:    stc     ; 80286ȉ̓L[𗧂ĂđI
                ret
CPUis386:       clc
                ret
CheckCurrentCPU ENDP

;-----------------------------
;       Beep3
;-----------------------------
Beep3           PROC   near
                push    cx
                push    ax
                mov     al,6
                out     37h,al
                mov     cx,3333h
Beep3Enter:
                jmp     $+2
                out     5Fh,al
                jmp     $+2
                out     5Fh,al
               loop     Beep3Enter
                mov     al,7
                out     37h,al
                mov     cx,4444h
Beep3Exit:
                jmp     $+2
                out     5Fh,al
                jmp     $+2
                out     5Fh,al
               loop     Beep3Exit
                pop     ax
                pop     cx
                ret
Beep3           ENDP

